-- Icon Button 

local Settings = Turbine.PluginData.Load(Turbine.DataScope.Character, "StableGuySettings");
local IconX,IconY=Turbine.UI.Display:GetWidth()/2-100,Turbine.UI.Display:GetHeight()/2-100;
if Settings~=nil then
  if Settings["IconPosX"]~=nil then IconX=Settings["IconPosX"] end
  if Settings["IconPosY"]~=nil then IconY=Settings["IconPosY"] end
end

IconButton = Turbine.UI.Window();
IconButton:SetSize(32,32);
IconButton:SetBackground("RadicusPlugins/StableGuy/Resources/Icon.tga");
IconButton:SetPosition(IconX,IconY);
IconButton:SetVisible(true);

IconButton.MouseClick = function (sender, args)
	if (args.Button == Turbine.UI.MouseButton.Right) then wStableGuy:SetVisible(true) end;
end

-- IconButton.MouseDoubleClick = function (sender, args)
-- 	if wStableGuy:IsVisible() == false then wStableGuy:SetVisible(true) end;
-- end

IconButtonDragging = false;

IconButton.MouseDown = function (sender, args)
	IconButtonDragging = true;
end

IconButton.MouseUp = function (sender, args)
	IconButtonDragging = false;
end

IconButton.MouseMove = function (sender, args)
	if IconButtonDragging == true then
		local curX = Turbine.UI.Display.GetMouseX();
		local curY = Turbine.UI.Display.GetMouseY();
		local scWidth = Turbine.UI.Display.GetWidth();
		local scHeight = Turbine.UI.Display.GetHeight();
		local curLeft = curX - 12;
		local curTop = curY -12;
		if (curX-12) < 0 then curLeft = 0 end;
		if (curX+12) > scWidth then curLeft = scWidth-32 end;
		if (curY-12) < 0 then curTop = 0 end;
		if (curY+12) > scHeight then curTop = scHeight-32 end;
		IconButton:SetLeft(curLeft);
		IconButton:SetTop(curTop);
		local farRight = IconButton:GetLeft() + IconButton:GetWidth();
		if farRight > Turbine.UI.Display.GetWidth() then
			IconButton:SetLeft(IconButton:GetLeft());
		else
			IconButton:SetLeft(IconButton:GetLeft());
		end
	end
end

