-- Turbine Imports
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

import "RadicusPlugins.StableGuy.DropDown";
import "RadicusPlugins.StableGuy.IconButton";
import "RadicusPlugins.StableGuy.TableData";
import "RadicusPlugins.StableGuy.Dijkstra"; 
import "RadicusPlugins.StableGuy.Window";

version = "v12.00";

-- Count number of data entries
MaxStables = 0;
for k,v in pairs (LOCATIONS_Angmar) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Anorien_After_Battle) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Bree_Land) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Central_Gondor) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Dunland) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Eastern_Gondor) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_East_Rohan) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Enedwaith) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Ered_Luin) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Ered_Mithrin) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Eregion) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Eryn_Lasgalen) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Ettenmoors) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Far_Anorien) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Forochel) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Gap_Of_Rohan) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Great_River) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Iron_Hills) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Lone_Lands) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Lothlorien) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Mirkwood) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Misty_Mountains) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Mordor) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Mordor_Besieged) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Moria) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Nan_Curunir) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_North_Downs) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_North_Ithilien) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Old_Anorien) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Shire) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_The_Wastes) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Trollshaws) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Vales_of_Anduin) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Wells_of_Langflood) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_West_Rohan) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Western_Gondor) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (LOCATIONS_Wildermore) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (RAIDS) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (WARBANDS) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (POI) do
	MaxStables = MaxStables + 1;
end
for k,v in pairs (SOURCE) do
	MaxStables = MaxStables + 1;
end



Turbine.Shell.WriteLine("StableGuy " .. version .." Mounted... " .. MaxStables .. " Locations Loaded! Giddyup! ");

Turbine.Plugin.Unload = function (sender, args)
	local Settings={}
	Settings["IconPosX"]=IconButton:GetLeft();
	Settings["IconPosY"]=IconButton:GetTop();
	Settings["WindPosX"]=wStableGuy:GetLeft();
	Settings["WindPosY"]=wStableGuy:GetTop();
	Settings["WindState"]=wStableGuy:IsVisible();
	Turbine.PluginData.Save(Turbine.DataScope.Character, "StableGuySettings", Settings);
end

-- HidePanel on F12
local HidePanel = false;
Panel = wStableGuy;
Panel:SetWantsKeyEvents(true);
Panel.KeyDown = function(sender, args)
	if (args.Action == 268435635) then
		if HidePanel == false then
			HidePanel = true;
			IconButton:SetVisible(false);
			if Panel:IsVisible() == true then
				PanelVisible = true;
				Panel:SetVisible(false);
			else
				PanelVisible = false;
			end
		else
			HidePanel = false;
			IconButton:SetVisible(true);
			if PanelVisible == true then
				Panel:SetVisible(true);
			end
		end
	end
end